#!/usr/bin/env python

def named_app(name):
    def app(environ, start_response):
        start_response('200 OK', [('Content-Type', 'text/html')])
        return ['app name: <b>%s</b> <br> <a href="/">home</a>' % name]
    return app

mapping = { '/one': named_app('one'),
            '/two': named_app('two') }

def dispatcher(environ, start_response):
    request_url = environ['PATH_INFO']
    if request_url in mapping:
        return mapping[request_url](environ, start_response)
    else:
        start_response('200 OK', [('Content-Type', 'text/html')])
        return [' '.join('<a href="%s">%s</a>' % (prefix, prefix[1:])
                         for prefix in sorted(mapping.keys()))]

if __name__ == '__main__':
    from wsgiref.simple_server import make_server

    server = make_server('localhost', 8080, dispatcher)
    print "Listening: http://localhost:8080/"
    try:
        server.serve_forever()
    except KeyboardInterrupt:
        print "\nbye!"
